<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>doSomethingWithUploadFile</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
</head>
<body>
<h1 id="do-something-with-a-uploaded-file-and-populate-a-field-in-the-document-based-on-that">Do something with a uploaded file and populate a field in the document based on that</h1>
<p>Consider the following schema, where we describe a route with a gpx map file of some sort, and we want to populate a field “bounds” in that document computed from the uploaded file.</p>
<h2 id="the-schema">The schema</h2>
<div class="sourceCode" id="cb1"><pre class="sourceCode javascript"><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="im">import</span> RouteFileInput <span class="im">from</span> <span class="st">&quot;../components/RouteFileInput&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-2" title="2"><span class="im">export</span> <span class="im">default</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-3" title="3">  <span class="dt">name</span><span class="op">:</span> <span class="st">&quot;route&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-4" title="4">  <span class="dt">title</span><span class="op">:</span> <span class="st">&quot;Route&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-5" title="5">  <span class="dt">type</span><span class="op">:</span> <span class="st">&quot;document&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-6" title="6">  <span class="dt">fields</span><span class="op">:</span> [</a>
<a class="sourceLine" id="cb1-7" title="7">    <span class="op">{</span></a>
<a class="sourceLine" id="cb1-8" title="8">      <span class="dt">name</span><span class="op">:</span> <span class="st">&quot;title&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-9" title="9">      <span class="dt">title</span><span class="op">:</span> <span class="st">&quot;Title&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-10" title="10">      <span class="dt">type</span><span class="op">:</span> <span class="st">&quot;string&quot;</span></a>
<a class="sourceLine" id="cb1-11" title="11">    <span class="op">},</span></a>
<a class="sourceLine" id="cb1-12" title="12">    <span class="op">{</span></a>
<a class="sourceLine" id="cb1-13" title="13">      <span class="dt">title</span><span class="op">:</span> <span class="st">&quot;Map&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-14" title="14">      <span class="dt">name</span><span class="op">:</span> <span class="st">&quot;map&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-15" title="15">      <span class="dt">type</span><span class="op">:</span> <span class="st">&quot;object&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-16" title="16">      <span class="dt">inputComponent</span><span class="op">:</span> RouteFileInput<span class="op">,</span></a>
<a class="sourceLine" id="cb1-17" title="17">      <span class="dt">fields</span><span class="op">:</span> [</a>
<a class="sourceLine" id="cb1-18" title="18">        <span class="op">{</span></a>
<a class="sourceLine" id="cb1-19" title="19">          <span class="dt">title</span><span class="op">:</span> <span class="st">&quot;GPX file&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-20" title="20">          <span class="dt">name</span><span class="op">:</span> <span class="st">&quot;mapfile&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-21" title="21">          <span class="dt">type</span><span class="op">:</span> <span class="st">&quot;file&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-22" title="22">        <span class="op">},</span></a>
<a class="sourceLine" id="cb1-23" title="23">        <span class="op">{</span></a>
<a class="sourceLine" id="cb1-24" title="24">          <span class="dt">name</span><span class="op">:</span> <span class="st">&quot;bounds&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-25" title="25">          <span class="dt">title</span><span class="op">:</span> <span class="st">&quot;Bounds&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-26" title="26">          <span class="dt">description</span><span class="op">:</span> <span class="st">&quot;Will be populated by file upload&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb1-27" title="27">          <span class="dt">type</span><span class="op">:</span> <span class="st">&quot;string&quot;</span></a>
<a class="sourceLine" id="cb1-28" title="28">        <span class="op">}</span></a>
<a class="sourceLine" id="cb1-29" title="29">      ]</a>
<a class="sourceLine" id="cb1-30" title="30">    <span class="op">}</span></a>
<a class="sourceLine" id="cb1-31" title="31">  ]</a>
<a class="sourceLine" id="cb1-32" title="32"><span class="op">};</span></a></code></pre></div>
<h2 id="the-input-component">The input component</h2>
<div class="sourceCode" id="cb2"><pre class="sourceCode javascript"><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="im">import</span> PropTypes <span class="im">from</span> <span class="st">&quot;prop-types&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb2-2" title="2"><span class="im">import</span> React <span class="im">from</span> <span class="st">&quot;react&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb2-3" title="3"><span class="im">import</span> Fieldset <span class="im">from</span> <span class="st">&quot;part:@sanity/components/fieldsets/default&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb2-4" title="4"><span class="im">import</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-5" title="5">  setIfMissing<span class="op">,</span></a>
<a class="sourceLine" id="cb2-6" title="6">  set<span class="op">,</span></a>
<a class="sourceLine" id="cb2-7" title="7">  unset</a>
<a class="sourceLine" id="cb2-8" title="8"><span class="op">}</span> <span class="im">from</span> <span class="st">&quot;part:@sanity/form-builder/patch-event&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb2-9" title="9"><span class="im">import</span> <span class="op">{</span> FormBuilderInput <span class="op">}</span> <span class="im">from</span> <span class="st">&quot;part:@sanity/form-builder&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb2-10" title="10"><span class="im">import</span> <span class="op">{</span> withDocument <span class="op">}</span> <span class="im">from</span> <span class="st">&quot;part:@sanity/form-builder&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb2-11" title="11"><span class="im">import</span> sanityClient <span class="im">from</span> <span class="st">&quot;part:@sanity/base/client&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb2-12" title="12"><span class="im">import</span> <span class="op">{</span> PatchEvent <span class="op">}</span> <span class="im">from</span> <span class="st">&quot;part:@sanity/form-builder&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb2-13" title="13"></a>
<a class="sourceLine" id="cb2-14" title="14"><span class="kw">function</span> <span class="at">computeBounds</span>(asset) <span class="op">{</span></a>
<a class="sourceLine" id="cb2-15" title="15">  <span class="cf">return</span> <span class="va">sanityClient</span>.<span class="at">getDocument</span>(<span class="va">asset</span>.<span class="at">_ref</span>).<span class="at">then</span>(asset <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-16" title="16">    <span class="va">console</span>.<span class="at">log</span>(<span class="st">&quot;Computing bounds for map file&quot;</span><span class="op">,</span> <span class="va">asset</span>.<span class="at">url</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-17" title="17">    <span class="kw">const</span> <span class="op">{</span> url <span class="op">}</span> <span class="op">=</span> asset<span class="op">;</span></a>
<a class="sourceLine" id="cb2-18" title="18">    <span class="co">// Fetch file, and compute bounds here then return the result</span></a>
<a class="sourceLine" id="cb2-19" title="19">    <span class="co">// (let&#39;s pretend it&#39;s done here for the sake of the example)</span></a>
<a class="sourceLine" id="cb2-20" title="20">    <span class="cf">return</span> <span class="op">{</span> <span class="dt">north</span><span class="op">:</span> <span class="dv">0</span><span class="op">,</span> <span class="dt">south</span><span class="op">:</span> <span class="dv">10</span><span class="op">,</span> <span class="dt">west</span><span class="op">:</span> <span class="dv">20</span><span class="op">,</span> <span class="dt">east</span><span class="op">:</span> <span class="dv">40</span> <span class="op">};</span></a>
<a class="sourceLine" id="cb2-21" title="21">  <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-22" title="22"><span class="op">}</span></a>
<a class="sourceLine" id="cb2-23" title="23"></a>
<a class="sourceLine" id="cb2-24" title="24"><span class="kw">class</span> CustomObjectInput <span class="kw">extends</span> <span class="va">React</span>.<span class="at">PureComponent</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-25" title="25">  <span class="kw">static</span> propTypes <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-26" title="26">    <span class="dt">type</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">shape</span>(<span class="op">{</span></a>
<a class="sourceLine" id="cb2-27" title="27">      <span class="dt">title</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">string</span><span class="op">,</span></a>
<a class="sourceLine" id="cb2-28" title="28">      <span class="dt">name</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">string</span></a>
<a class="sourceLine" id="cb2-29" title="29">    <span class="op">}</span>).<span class="at">isRequired</span><span class="op">,</span></a>
<a class="sourceLine" id="cb2-30" title="30">    <span class="dt">level</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">number</span><span class="op">,</span></a>
<a class="sourceLine" id="cb2-31" title="31">    <span class="dt">value</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">shape</span>(<span class="op">{</span></a>
<a class="sourceLine" id="cb2-32" title="32">      <span class="dt">_type</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">string</span></a>
<a class="sourceLine" id="cb2-33" title="33">    <span class="op">}</span>)<span class="op">,</span></a>
<a class="sourceLine" id="cb2-34" title="34">    <span class="dt">focusPath</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="va">array</span>.<span class="at">isRequired</span><span class="op">,</span></a>
<a class="sourceLine" id="cb2-35" title="35">    <span class="dt">onFocus</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="va">func</span>.<span class="at">isRequired</span><span class="op">,</span></a>
<a class="sourceLine" id="cb2-36" title="36">    <span class="dt">onChange</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="va">func</span>.<span class="at">isRequired</span><span class="op">,</span></a>
<a class="sourceLine" id="cb2-37" title="37">    <span class="dt">onBlur</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="va">func</span>.<span class="at">isRequired</span></a>
<a class="sourceLine" id="cb2-38" title="38">  <span class="op">};</span></a>
<a class="sourceLine" id="cb2-39" title="39"></a>
<a class="sourceLine" id="cb2-40" title="40">  firstFieldInput <span class="op">=</span> <span class="va">React</span>.<span class="at">createRef</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb2-41" title="41"></a>
<a class="sourceLine" id="cb2-42" title="42">  handleFieldChange <span class="op">=</span> (field<span class="op">,</span> fieldPatchEvent) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-43" title="43">    <span class="kw">const</span> <span class="op">{</span> onChange<span class="op">,</span> type<span class="op">,</span> document <span class="op">}</span> <span class="op">=</span> <span class="kw">this</span>.<span class="at">props</span><span class="op">;</span></a>
<a class="sourceLine" id="cb2-44" title="44">    </a>
<a class="sourceLine" id="cb2-45" title="45">    <span class="co">// If we see a set patch that sets the asset, use the file to compute the bounds</span></a>
<a class="sourceLine" id="cb2-46" title="46">    <span class="kw">const</span> setAssetPatch <span class="op">=</span> <span class="va">fieldPatchEvent</span>.<span class="va">patches</span>.<span class="at">find</span>(</a>
<a class="sourceLine" id="cb2-47" title="47">      patch <span class="kw">=&gt;</span></a>
<a class="sourceLine" id="cb2-48" title="48">        <span class="va">patch</span>.<span class="at">type</span> <span class="op">===</span> <span class="st">&quot;set&quot;</span> <span class="op">&amp;&amp;</span></a>
<a class="sourceLine" id="cb2-49" title="49">        <span class="va">patch</span>.<span class="va">path</span>.<span class="at">length</span> <span class="op">===</span> <span class="dv">1</span> <span class="op">&amp;&amp;</span></a>
<a class="sourceLine" id="cb2-50" title="50">        <span class="va">patch</span>.<span class="at">path</span>[<span class="dv">0</span>] <span class="op">===</span> <span class="st">&quot;asset&quot;</span> <span class="op">&amp;&amp;</span></a>
<a class="sourceLine" id="cb2-51" title="51">        <span class="va">patch</span>.<span class="at">value</span> <span class="op">&amp;&amp;</span></a>
<a class="sourceLine" id="cb2-52" title="52">        <span class="va">patch</span>.<span class="va">value</span>.<span class="at">_ref</span></a>
<a class="sourceLine" id="cb2-53" title="53">    )<span class="op">;</span></a>
<a class="sourceLine" id="cb2-54" title="54">    <span class="cf">if</span> (<span class="va">field</span>.<span class="at">name</span> <span class="op">===</span> <span class="st">&quot;mapfile&quot;</span> <span class="op">&amp;&amp;</span> setAssetPatch) <span class="op">{</span></a>
<a class="sourceLine" id="cb2-55" title="55">      <span class="at">computeBounds</span>(<span class="va">setAssetPatch</span>.<span class="at">value</span>).<span class="at">then</span>(bounds <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-56" title="56">        <span class="at">onChange</span>(<span class="va">PatchEvent</span>.<span class="at">from</span>([<span class="at">set</span>(<span class="va">JSON</span>.<span class="at">stringify</span>(bounds)<span class="op">,</span> [<span class="st">&quot;bounds&quot;</span>])]))<span class="op">;</span></a>
<a class="sourceLine" id="cb2-57" title="57">      <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-58" title="58">    <span class="op">}</span></a>
<a class="sourceLine" id="cb2-59" title="59"></a>
<a class="sourceLine" id="cb2-60" title="60">    <span class="co">// If we see a patch that removes the map asset file, unset the bounds field</span></a>
<a class="sourceLine" id="cb2-61" title="61">    <span class="cf">if</span> (</a>
<a class="sourceLine" id="cb2-62" title="62">      <span class="va">fieldPatchEvent</span>.<span class="va">patches</span>.<span class="at">find</span>(</a>
<a class="sourceLine" id="cb2-63" title="63">        patch <span class="kw">=&gt;</span></a>
<a class="sourceLine" id="cb2-64" title="64">          <span class="va">patch</span>.<span class="at">type</span> <span class="op">===</span> <span class="st">&quot;unset&quot;</span> <span class="op">&amp;&amp;</span></a>
<a class="sourceLine" id="cb2-65" title="65">          <span class="va">patch</span>.<span class="va">path</span>.<span class="at">length</span> <span class="op">===</span> <span class="dv">1</span> <span class="op">&amp;&amp;</span></a>
<a class="sourceLine" id="cb2-66" title="66">          <span class="va">patch</span>.<span class="at">path</span>[<span class="dv">0</span>] <span class="op">===</span> <span class="st">&quot;asset&quot;</span></a>
<a class="sourceLine" id="cb2-67" title="67">      )</a>
<a class="sourceLine" id="cb2-68" title="68">    ) <span class="op">{</span></a>
<a class="sourceLine" id="cb2-69" title="69">      <span class="at">onChange</span>(<span class="va">PatchEvent</span>.<span class="at">from</span>([<span class="at">unset</span>([<span class="st">&quot;bounds&quot;</span>])]))<span class="op">;</span></a>
<a class="sourceLine" id="cb2-70" title="70">    <span class="op">}</span></a>
<a class="sourceLine" id="cb2-71" title="71"></a>
<a class="sourceLine" id="cb2-72" title="72">    <span class="at">onChange</span>(</a>
<a class="sourceLine" id="cb2-73" title="73">      fieldPatchEvent</a>
<a class="sourceLine" id="cb2-74" title="74">        .<span class="at">prefixAll</span>(<span class="va">field</span>.<span class="at">name</span>)</a>
<a class="sourceLine" id="cb2-75" title="75">        .<span class="at">prepend</span>(<span class="at">setIfMissing</span>(<span class="op">{</span> <span class="dt">_type</span><span class="op">:</span> <span class="va">type</span>.<span class="at">name</span> <span class="op">}</span>))</a>
<a class="sourceLine" id="cb2-76" title="76">    )<span class="op">;</span></a>
<a class="sourceLine" id="cb2-77" title="77">  <span class="op">};</span></a>
<a class="sourceLine" id="cb2-78" title="78"></a>
<a class="sourceLine" id="cb2-79" title="79">  <span class="at">focus</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb2-80" title="80">    <span class="kw">this</span>.<span class="va">firstFieldInput</span>.<span class="va">current</span>.<span class="at">focus</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb2-81" title="81">  <span class="op">}</span></a>
<a class="sourceLine" id="cb2-82" title="82"></a>
<a class="sourceLine" id="cb2-83" title="83">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb2-84" title="84">    <span class="kw">const</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-85" title="85">      document<span class="op">,</span></a>
<a class="sourceLine" id="cb2-86" title="86">      type<span class="op">,</span></a>
<a class="sourceLine" id="cb2-87" title="87">      value<span class="op">,</span></a>
<a class="sourceLine" id="cb2-88" title="88">      level<span class="op">,</span></a>
<a class="sourceLine" id="cb2-89" title="89">      focusPath<span class="op">,</span></a>
<a class="sourceLine" id="cb2-90" title="90">      onFocus<span class="op">,</span></a>
<a class="sourceLine" id="cb2-91" title="91">      onBlur</a>
<a class="sourceLine" id="cb2-92" title="92">    <span class="op">}</span> <span class="op">=</span> <span class="kw">this</span>.<span class="at">props</span><span class="op">;</span></a>
<a class="sourceLine" id="cb2-93" title="93">    <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb2-94" title="94">      <span class="op">&lt;</span>Fieldset</a>
<a class="sourceLine" id="cb2-95" title="95">        level<span class="op">={</span>level<span class="op">}</span></a>
<a class="sourceLine" id="cb2-96" title="96">        legend<span class="op">={</span><span class="va">type</span>.<span class="at">title</span><span class="op">}</span></a>
<a class="sourceLine" id="cb2-97" title="97">        description<span class="op">={</span><span class="va">type</span>.<span class="at">description</span><span class="op">}</span></a>
<a class="sourceLine" id="cb2-98" title="98">      <span class="op">&gt;</span></a>
<a class="sourceLine" id="cb2-99" title="99">        <span class="op">&lt;</span>div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb2-100" title="100">          <span class="op">{</span><span class="va">type</span>.<span class="va">fields</span>.<span class="at">map</span>((field<span class="op">,</span> i) <span class="kw">=&gt;</span> (</a>
<a class="sourceLine" id="cb2-101" title="101">            <span class="co">// Delegate to the generic FormBuilderInput. It will resolve and insert the actual input component</span></a>
<a class="sourceLine" id="cb2-102" title="102">            <span class="co">// for the given field type</span></a>
<a class="sourceLine" id="cb2-103" title="103">            <span class="op">&lt;</span>FormBuilderInput</a>
<a class="sourceLine" id="cb2-104" title="104">              level<span class="op">={</span>level <span class="op">+</span> <span class="dv">1</span><span class="op">}</span></a>
<a class="sourceLine" id="cb2-105" title="105">              ref<span class="op">={</span>i <span class="op">===</span> <span class="dv">0</span> <span class="op">?</span> <span class="kw">this</span>.<span class="at">firstFieldInput</span> : <span class="kw">null</span><span class="op">}</span></a>
<a class="sourceLine" id="cb2-106" title="106">              key<span class="op">={</span><span class="va">field</span>.<span class="at">name</span><span class="op">}</span></a>
<a class="sourceLine" id="cb2-107" title="107">              type<span class="op">={</span><span class="va">field</span>.<span class="at">type</span><span class="op">}</span></a>
<a class="sourceLine" id="cb2-108" title="108">              value<span class="op">={</span>value <span class="op">&amp;&amp;</span> value[<span class="va">field</span>.<span class="at">name</span>]<span class="op">}</span></a>
<a class="sourceLine" id="cb2-109" title="109">              onChange<span class="op">={</span>patchEvent <span class="kw">=&gt;</span> <span class="kw">this</span>.<span class="at">handleFieldChange</span>(field<span class="op">,</span> patchEvent)<span class="op">}</span></a>
<a class="sourceLine" id="cb2-110" title="110">              path<span class="op">={</span>[<span class="va">field</span>.<span class="at">name</span>]<span class="op">}</span></a>
<a class="sourceLine" id="cb2-111" title="111">              focusPath<span class="op">={</span>focusPath<span class="op">}</span></a>
<a class="sourceLine" id="cb2-112" title="112">              onFocus<span class="op">={</span>onFocus<span class="op">}</span></a>
<a class="sourceLine" id="cb2-113" title="113">              onBlur<span class="op">={</span>onBlur<span class="op">}</span></a>
<a class="sourceLine" id="cb2-114" title="114">            /&gt;</a>
<a class="sourceLine" id="cb2-115" title="115">          ))<span class="op">}</span></a>
<a class="sourceLine" id="cb2-116" title="116">        &lt;/div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb2-117" title="117">      &lt;/Fieldset<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb2-118" title="118">    )<span class="op">;</span></a>
<a class="sourceLine" id="cb2-119" title="119">  <span class="op">}</span></a>
<a class="sourceLine" id="cb2-120" title="120"><span class="op">}</span></a>
<a class="sourceLine" id="cb2-121" title="121"></a>
<a class="sourceLine" id="cb2-122" title="122"><span class="im">export</span> <span class="im">default</span> <span class="at">withDocument</span>(CustomObjectInput)<span class="op">;</span></a></code></pre></div>
</body>
</html>
